﻿var hubber = $.connection.jobUpdaterHub;

$(function () {
    //$.connection.hub.logging = true;
    $.connection.hub.start().done(function () {
        hubber.server.initConnection();
        hubber.server.updateAll();
        redrawMain();
    });
    hubber.client.processData = function (id, data) {
        var obj = JSON.parse(data);
        editTaskData(id, obj);
        saveData(id, obj.StateLog);
    }
    hubber.client.requestDone = function () {
        
        setTimeout(function () {
            hubber.server.updateAll();
            console.log("#REFRESH ALL");
            
        }, 5000);
    }
    //hubber.c
})

function editTaskData(id, task) {
    //lastupdate
    var dat = new Date(task.LastHeartbeat);
    $("#lastupdpar" + id).html("Last update: " + dat.toUTCString());
    //state
    if (task.State == "1") {
        $("#statepar" + id).css({
            'color': 'white',
            'font-weight': 'normal'
        });
        $("#statepar" + id).html("State: Waiting");
    }
    else if (task.State == "2") {
        $("#statepar" + id).css({
            'color': 'white',
            'font-weight': 'normal'
        });
        $("#statepar" + id).html("State: Transferring");
    }
    else if (task.State == "3") {
        $("#statepar" + id).css({
            'color': 'white',
            'font-weight': 'normal'
        });
        $("#statepar" + id).html("State: Calculating");
    }
    else if (task.State == "5") {
        $("#statepar" + id).css({
            'color': '#009900',
            'font-weight': '900'
        });
        $("#statepar" + id).html("State: Finished");
        var datf = new Date(task.StateLog[task.StateLog.length -1].DateTime);
        $("#lastupdpar" + id).html("Finished: " + datf.toUTCString());
    }
    else if (task.State == "7") {
        $("#statepar" + id).css({
            'color': '#df2020',
            'font-weight': '900'
        });
        $("#statepar" + id).html("State: Failed");
    }
    
    //execution time
    $("#executionpar" + id).html(task.ExecutionTime + " executed");
    //state changes
    $("#statechangespar" + id).html("Statelogs: "+task.StateLog.length);
    //graph title
    var dat1 = new Date(task.StateLog[0].DateTime);
    var dat2 = new Date(task.StateLog[task.StateLog.length - 1].DateTime);
    $("#graphtitle" + id).html(
        "From " + dat1.toUTCString() +
        "<br/> to " + dat2.toUTCString()
        );
}